#ifndef __PALETTE_H
#define __PALETTE_H

#include <gtk/gtk.h>
#include "fractal_types.h"

/* these probably only work on little-endian machines */
#define RGB(r,g,b) ((r) | ((g) << 8) | ((b) << 16))
#define RED(x) ((x) & 0x000000ff)
#define GREEN(x) (((x) & 0x0000ff00) >> 8)
#define BLUE(x) (((x) & 0x00ff0000) >> 16)

gboolean palette_load(char* filename);
char* palette_get_filename(void);
void palette_apply(image_info* img, int x0, int y0, int width, int height);
void palette_invert(void);
guint32 get_pixel(image_info* img, int x, int y);

#endif /* __PALETTE_H */
